"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Returns the value of the requested header in a case insensitive way.
 *
 * @param {Object} headers The headers object.
 * @param {string} headerName The name of the header we need.
 * @returns string | undefined
 */
function getHeaderValue(headers, headerName) {
    var actualHeaderName = Object.keys(headers).find(function (key) { return key.toLowerCase() === headerName.toLowerCase(); });
    if (actualHeaderName === undefined) {
        return undefined;
    }
    return headers[actualHeaderName];
}
exports.default = getHeaderValue;
//# sourceMappingURL=getHeaderValue.js.map